package com.zhongzheng.modules.course.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.course.bo.CourseMenuAddBo;
import com.zhongzheng.modules.course.bo.CourseMenuEditBo;
import com.zhongzheng.modules.course.bo.CourseMenuListAddBo;
import com.zhongzheng.modules.course.bo.CourseMenuQueryBo;
import com.zhongzheng.modules.course.domain.CourseMenu;
import com.zhongzheng.modules.course.vo.CourseMenuVo;
import com.zhongzheng.modules.course.vo.CourseUserMenuVo;

import java.util.Collection;
import java.util.List;

/**
 * 课程目录结构Service接口
 *
 * @author hjl
 * @date 2021-10-12
 */
public interface ICourseMenuService extends IService<CourseMenu> {
	/**
	 * 查询单个
	 * @return
	 */
	CourseMenuVo queryById(Long id);

	List<CourseMenuVo> selectList(CourseMenuQueryBo bo);

	/**
	 * 查询列表
	 */
	List<CourseMenuVo> queryList(CourseMenuQueryBo bo);

	/**
	 * 根据新增业务对象插入课程目录结构
	 * @param bo 课程目录结构新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(CourseMenuListAddBo bo);

	/**
	 * 根据编辑业务对象修改课程目录结构
	 * @param bo 课程目录结构编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(CourseMenuListAddBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	List<CourseUserMenuVo> menuList(CourseMenuQueryBo bo);
}
